using System;
using System.Collections.Generic;
using System.Text;

namespace mbe
{
	public class MbeLayer
	{
		/// <summary>
		/// C[rbg enuml
		/// </summary>
		/// <remarks>
		/// (LayerValue &amp; 0x00000000000000AA)[ɂȂȂƂ͔cʑ
		/// (LayerValue &amp; 0xFF00000000000000)[ɂȂȂC[͖ʈˑȂ
		/// </remarks>
		public enum LayerValue : ulong
		{
			NUL =	0,
			PLC =	0x0000000000000001L,
			PLS =	0x0000000000000002L,
			STC =	0x0000000000000004L,
			STS =	0x0000000000000008L,
			CMP =	0x0000000000000010L,
			SOL =	0x0000000000000020L,
			DIM =	0x8000000000000000L,
			PTH =   0x4000000000000000L,
			DRL =	0x2000000000000000L,
			DOC =	0x1000000000000040L
		};


		public enum LayerIndex	//̏ŕ`悳
		{
			PTH=0,
			PLC,
			STC,
			CMP,
			SOL,
			STS,
			PLS,
			DIM,
			DRL,
			DOC
		};


		/// <summary>
		/// C[ e[u
		/// </summary>
		public static readonly string[] nameTable = 
		{ 
			"PTH",
			"PLC",
			"STC", 
			"CMP", 
			"SOL", 
			"STS", 
			"PLS",
			"DIM",
			"DRL",
			"DOC"
		};

		/// <summary>
		/// C[ rbgle[u
		/// </summary>
		public static readonly LayerValue[] valueTable =
		{
			LayerValue.PTH,
			LayerValue.PLC,
			LayerValue.STC,
			LayerValue.CMP,
			LayerValue.SOL,
			LayerValue.STS,
			LayerValue.PLS,
			LayerValue.DIM,
			LayerValue.DRL,
			LayerValue.DOC
		};


		/// <summary>
		/// LayerValuelɑΉ郌C[𓾂
		/// </summary>
		/// <param name="layer"></param>
		/// <returns></returns>
		public static string GetLayerName(LayerValue layer)
		{
			int count = valueTable.Length;
			for (int i = 0; i < count; i++) {
				if (valueTable[i] == layer) {
					return nameTable[i];
				}
			}
			return "DOC";
		}

		/// <summary>
		/// name ɑΉ LayerValueԂB
		/// </summary>
		/// <param name="name"></param>
		/// <returns></returns>
		public static LayerValue GetLayerValue(string name)
		{
			int count = nameTable.Length;
			for (int i = 0; i < count; i++) {
				if (nameTable[i] == name) {
					return valueTable[i];
				}
			}
			return LayerValue.DOC;
		}

		/// <summary>
		/// iʁA܂͖ʈˑ̂ȂC[ǂ𒲂ׂ
		/// </summary>
		/// <param name="value"></param>
		/// <returns></returns>
		public static bool IsComponentSide(LayerValue value)
		{
			return ((ulong)value & 0x00000000000000AAL)==0;
		}

		/// <summary>
		/// C[lʔ]
		/// </summary>
		/// <param name="value"></param>
		/// <returns></returns>
		public static LayerValue Flip(LayerValue value)
		{
			switch(value){
				case LayerValue.PLC:	return LayerValue.PLS;
				case LayerValue.PLS:	return LayerValue.PLC;
				case LayerValue.STC:	return LayerValue.STS;
				case LayerValue.STS:	return LayerValue.STC;
				case LayerValue.CMP:	return LayerValue.SOL;
				case LayerValue.SOL:	return LayerValue.CMP;
				default: return value; //DIM,DOC,PTH,DRL̓C[𔽓]Ȃ
			}
		}
	}
}
